package cn.com.qmth.mps.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import cn.com.qmth.mps.bean.PaperDetail;
import cn.com.qmth.mps.bean.PaperDetailUnit;
import cn.com.qmth.mps.dao.PaperDetailDao;
import cn.com.qmth.mps.entity.PaperDetailEntity;
import cn.com.qmth.mps.service.PaperDetailService;
import cn.com.qmth.mps.service.PaperDetailUnitService;

@Service
public class PaperDetailServiceImpl extends ServiceImpl<PaperDetailDao, PaperDetailEntity>
		implements PaperDetailService {
	@Autowired
	private PaperDetailUnitService paperDetailUnitService;

	@Override
	public List<PaperDetail> getStructInfo(Long paperId) {
		List<PaperDetail> ret = new ArrayList<>();
		List<PaperDetailEntity> es = getByPaperId(paperId);
		if (CollectionUtils.isEmpty(es)) {
			return ret;
		}
		Map<Long,PaperDetail> map=new HashMap<>();
		for(PaperDetailEntity e:es) {
			PaperDetail vo=new PaperDetail();
			vo.setName(e.getName());
			vo.setNumber(e.getNumber());
			map.put(e.getId(), vo);
			ret.add(vo);
		}
		Map<Long,List<PaperDetailUnit>> units=paperDetailUnitService.getStructInfo(paperId);
		if (units==null||units.size()==0) {
			return ret;
		}
		for(Long key:units.keySet()) {
			map.get(key).setUnits(units.get(key));
		}
		return ret;
	}

	private List<PaperDetailEntity> getByPaperId(Long paperId) {
		QueryWrapper<PaperDetailEntity> wrapper = new QueryWrapper<>();
		LambdaQueryWrapper<PaperDetailEntity> lw = wrapper.lambda();
		lw.eq(PaperDetailEntity::getPaperId, paperId);
		return this.list(wrapper);
	}
}
