package cn.com.qmth.mps.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import cn.com.qmth.mps.bean.PaperGroup;
import cn.com.qmth.mps.bean.PaperGroupUnit;
import cn.com.qmth.mps.dao.PaperGroupDao;
import cn.com.qmth.mps.entity.PaperGroupEntity;
import cn.com.qmth.mps.service.PaperGroupService;
import cn.com.qmth.mps.service.PaperGroupUnitService;
import cn.com.qmth.mps.vo.paper.GroupCountVo;

@Service
public class PaperGroupServiceImpl extends ServiceImpl<PaperGroupDao, PaperGroupEntity> implements PaperGroupService {
	@Autowired
	private PaperGroupUnitService paperGroupUnitService;
	@Override
	public List<GroupCountVo> findGroupCount(List<Long> paperIds) {
		return this.baseMapper.findGroupCount(paperIds);
	}

	@Override
	public List<PaperGroup> getGroupInfo(Long paperId) {
		List<PaperGroup> ret = new ArrayList<>();
		List<PaperGroupEntity> es = getByPaperId(paperId);
		if (CollectionUtils.isEmpty(es)) {
			return ret;
		}
		Map<Long,PaperGroup> map=new HashMap<>();
		for(PaperGroupEntity e:es) {
			PaperGroup vo=new PaperGroup();
			vo.setNumber(e.getNumber());
			map.put(e.getId(), vo);
			ret.add(vo);
		}
		Map<Long,List<PaperGroupUnit>> units=paperGroupUnitService.getGroupInfo(paperId);
		if (units==null||units.size()==0) {
			return ret;
		}
		for(Long key:units.keySet()) {
			map.get(key).setGroupUnits(units.get(key));
		}
		return ret;
	}
	private List<PaperGroupEntity> getByPaperId(Long paperId) {
		QueryWrapper<PaperGroupEntity> wrapper = new QueryWrapper<>();
		LambdaQueryWrapper<PaperGroupEntity> lw = wrapper.lambda();
		lw.eq(PaperGroupEntity::getPaperId, paperId);
		return this.list(wrapper);
	}

}
